<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<title>Bootstrap Flex</title>
	<!-- bootstrap -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
<!-- google font -->
	<link rel="preconnect" href="https://fonts.googleapis.com">
<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
<link href="https://fonts.googleapis.com/css2?family=Open+Sans&family=Oswald&family=Praise&display=swap" rel="stylesheet">
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 
		Flexbox is used to manipulate and layout out elements. This can be done exclusively in CSS. However, using bootstrap it is much eeasier and faster to implement flex becaue all we have to do is add the class d-flex to the parent of our parent of our flex items.

		Flex items, Flex Children, when adding d-flex to their parent, the items are in a row. We can adjust thier height and width not like yur inline elements.
		
		Flex Direction:

		You can change the direction of your flex items by adding flex-directin, however, by default, flex-row is the arrangement of our flex items.

		Flex Row Reverse
		Starts our items from the opposite side(right) and reverses the order of our flex items.

		flex-row starts from left to right. (default)
		flex-row-reverse starts from right to left.

		Flex column
		Flex colum will arrange our item from top to bottom and by default the flex items will occupy the width of its parent

		Flex Ccolum Revese
		Does the same
	 -->
	 <h3 class="text-center my-3">Flex Row</h3>
	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex mb-4" >
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>
	<h3 class="text-center my-5" >Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-column mb-4 p-4">
		<span class="bg-primary p-2" >Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>
	<h3 class="text-center my-5">Flex Column Reverse</h3>
	<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- justify-content allows us to manipulate and chnge the alignment of our flex items along our main axis. the main axis for flex-row items is our
	x.asix. justify content allow us to horizontally align our flex-row items -->
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- justify-content-start the default value of justify-content for flex items. It allows us to align our flex items to the start of thier main axis. For flex-row it starts from the right-->
	<div class="bg-dark d-flex flex-row justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- align our flex item where our main axis ends For flex-row, the end from the right, for flex-row reverse, the end is from the left -->
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Center</h3>
	<!-- Aligns our flex-items at the center of the main axis. The main axis for both flex-row and flex-row-reverse is the x-axis -->
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Between</h3>
	<!-- justify-content-between add/distributes remaining spaces in between out items-->
	<div class="d-flex flex-row justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Around</h3>
	<!-- Aligns our items by distributng space around your items. Meaning it will Automatically calculate the space remaing and add that space around your items -->
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<!-- Align Items -->
	<h2 class="text-center">Align Item</h2>
	<!-- align-items - aligns your items vertically for flex-row and flex-row-reverse -->
	<h3 class="text-center">Align Items Start</h3>
	<!-- align---items-start - align items at the start of the y axis or cross-axis for flex-row and flex-row-reverse.
		
		Flor flex-row and flex-row-reverse, the y-axis and the x-axis is their main axis.

		For flex-column and flex-olumn-reveerse, the y-axis is the main axis and-x-asix is 

	 -->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Align Items End</h3>
	<!-- align items-end will align our flex-row and flex-row-reverse items at the end of thier cross axis, which -->
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
 	<h3 class="text-center my-5">Align Items Center</h3>
 	<!-- align-items-center allows us to align our flex-row and -->
 	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height: 50vh;">
 		<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	</div>
 	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height: 50vh;">
 		<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	</div>

 	<h2 class="text-center my-5">Aligning Items Horizintally and Vertically</h2>
 	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height: 50vh;">
 		<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	</div>
 	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height: 50vh;">
 		<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	</div>
 	 	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height: 50vh;">
 		<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	</div>

 	<!-- Mini-Activity:

		Add an h3 with the text Mini-Activity with Flex Row
		-center
 	 -->

 	 <h3 class="text-center my-5">Mini-Activity with Flex Row</h3>
 	 <div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4" style="height: 50vh;">
 	 	<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	 </div>
 	  <div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4" style="height: 50vh;">
 	 	<div class="bg-primary p-2">Flex Item 1</div>
 		<div class="bg-danger p-2">Flex Item 2</div>
 		<div class="bg-success p-2">Flex Item 3</div>
 	 </div>

 	 <h2 class="text-center my-5">Flex Column with Align Items and Justify Content</h2>

 	 <!-- 
		For flex-row and flex-row-reverse, align-items aligns our flex-row vertically, justify-content aligns our flex-row and flex-row-reverse horiozntally.

		Flor flex-column and flex-column-reverse, aligns our flex-column and flex-colum-reverse horizontally, justify-content aligns our flex and flex-reverse vertically.
 	  -->
 	 <div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
 	 	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 		<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
 	 </div> 
 	  	 <div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
 	 	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 		<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
 	 </div> 
 	 <!-- Mini-Acitivity -->
 	 <h3 class=" text-center my-5">Mini Activity with Flex Column</h3>

 	   	 <div class="d-flex flex-column justify-content-end bg-dark mb-4" style="height:50vh;">
 	  	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 	 	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 	 	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>

 	   	 </div> 
 	  	 <div class="d-flex flex-column align-items-end bg-dark mb-4" style="height:50vh;">
 	 	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 		<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
 	 </div>

 	 <h3 class="text-center my-5">Flex Column with Justify Content between and Around</h3>
 	    <div class="d-flex flex-column justify-content-between bg-dark mb-4" style="height:50vh;">
 	   	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 	  	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 	  	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>

 	    </div> 
 	   	 <div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
 	  	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
 	 	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
 	 	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
 	  </div>

 	  <h3 class="text-center my-5">Flex Wrap</h3>
 	  <div class="d-flex justify-content-around flex-row flex-wrap bg-dark mb-4">
 	  	 	<div class="bg-primary p-2">Flex Item 1</div>
 	  		<div class="bg-danger p-2">Flex Item 2</div>
 	  		<div class="bg-success p-2">Flex Item 3</div>
 	  		<div class="bg-primary p-2">Flex Item 1</div>
 	  		<div class="bg-danger p-2">Flex Item 2</div>
 	  		<div class="bg-success p-2">Flex Item 3</div>
 	  		<div class="bg-primary p-2">Flex Item 1</div>
 	  		<div class="bg-danger p-2">Flex Item 2</div>
 	  		<div class="bg-success p-2">Flex Item 3</div>

 	  </div>


<!-- js -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>